<center><a href="ex7.c">Actual source code: ex7.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:08+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests matrix factorization.  Note that most users should\n\</font>
<a name="line3">  3: </a><font color="#666666">employ the <A href="../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>  interface to the linear solvers instead of using the factorization\n\</font>
<a name="line4">  4: </a><font color="#666666">routines directly.\n\n"</font>;

<a name="line6"> 6: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line10"> 10: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line11"> 11: </a>{
<a name="line12"> 12: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            C,LU;
<a name="line13"> 13: </a>  <A href="../../../../docs/manualpages/Mat/MatInfo.html#MatInfo">MatInfo</A>        info;
<a name="line14"> 14: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j,m = 3,n = 3,Ii,J;
<a name="line16"> 16: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    v,one = 1.0;
<a name="line17"> 17: </a>  <A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A>             perm,iperm;
<a name="line18"> 18: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x,u,b;
<a name="line19"> 19: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      norm;
<a name="line20"> 20: </a>  <A href="../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>  luinfo;

<a name="line22"> 22: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);

<a name="line24"> 24: </a>  <font color="#B22222">/* Create the matrix for the five point stencil, YET AGAIN */</font>
<a name="line25"> 25: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,&amp;C);
<a name="line26"> 26: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(C,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,m*n,m*n);
<a name="line27"> 27: </a>  <A href="../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>(C);
<a name="line28"> 28: </a>  <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line29"> 29: </a>    <font color="#4169E1">for</font> (j=0; j&lt;n; j++) {
<a name="line30"> 30: </a>      v = -1.0;  Ii = j + n*i;
<a name="line31"> 31: </a>      <font color="#4169E1">if</font> (i&gt;0)   {J = Ii - n; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line32"> 32: </a>      <font color="#4169E1">if</font> (i&lt;m-1) {J = Ii + n; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line33"> 33: </a>      <font color="#4169E1">if</font> (j&gt;0)   {J = Ii - 1; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line34"> 34: </a>      <font color="#4169E1">if</font> (j&lt;n-1) {J = Ii + 1; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;J,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);}
<a name="line35"> 35: </a>      v = 4.0; <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,1,&amp;Ii,1,&amp;Ii,&amp;v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line36"> 36: </a>    }
<a name="line37"> 37: </a>  }
<a name="line38"> 38: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(C,MAT_FINAL_ASSEMBLY);
<a name="line39"> 39: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(C,MAT_FINAL_ASSEMBLY);
<a name="line40"> 40: </a>  <A href="../../../../docs/manualpages/MatOrderings/MatGetOrdering.html#MatGetOrdering">MatGetOrdering</A>(C,MATORDERING_RCM,&amp;perm,&amp;iperm);
<a name="line41"> 41: </a>  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(C,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);
<a name="line42"> 42: </a>  <A href="../../../../docs/manualpages/IS/ISView.html#ISView">ISView</A>(perm,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);

<a name="line44"> 44: </a>  <A href="../../../../docs/manualpages/Mat/MatFactorInfoInitialize.html#MatFactorInfoInitialize">MatFactorInfoInitialize</A>(&amp;luinfo);
<a name="line45"> 45: </a>  luinfo.fill = 2.0;
<a name="line46"> 46: </a>  luinfo.dtcol = 0.0;
<a name="line47"> 47: </a>  luinfo.shiftnz = 0.0;
<a name="line48"> 48: </a>  luinfo.zeropivot = 1.e-14;
<a name="line49"> 49: </a>  luinfo.pivotinblocks = 1.0;
<a name="line50"> 50: </a>  <A href="../../../../docs/manualpages/Mat/MatLUFactorSymbolic.html#MatLUFactorSymbolic">MatLUFactorSymbolic</A>(C,perm,iperm,&amp;luinfo,&amp;LU);
<a name="line51"> 51: </a>  <A href="../../../../docs/manualpages/Mat/MatLUFactorNumeric.html#MatLUFactorNumeric">MatLUFactorNumeric</A>(C,&amp;luinfo,&amp;LU);
<a name="line52"> 52: </a>  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(LU,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);

<a name="line54"> 54: </a>  <A href="../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,m*n,&amp;u);
<a name="line55"> 55: </a>  <A href="../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(u,one);
<a name="line56"> 56: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(u,&amp;x);
<a name="line57"> 57: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(u,&amp;b);

<a name="line59"> 59: </a>  <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(C,u,b);
<a name="line60"> 60: </a>  <A href="../../../../docs/manualpages/Mat/MatSolve.html#MatSolve">MatSolve</A>(LU,b,x);

<a name="line62"> 62: </a>  <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(b,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);
<a name="line63"> 63: </a>  <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(x,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);

<a name="line65"> 65: </a>  <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(x,-1.0,u);
<a name="line66"> 66: </a>  <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(x,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm);
<a name="line67"> 67: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Norm of error %A\n"</font>,norm);

<a name="line69"> 69: </a>  <A href="../../../../docs/manualpages/Mat/MatGetInfo.html#MatGetInfo">MatGetInfo</A>(C,MAT_LOCAL,&amp;info);
<a name="line70"> 70: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"original matrix nonzeros = %D\n"</font>,(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)info.nz_used);
<a name="line71"> 71: </a>  <A href="../../../../docs/manualpages/Mat/MatGetInfo.html#MatGetInfo">MatGetInfo</A>(LU,MAT_LOCAL,&amp;info);
<a name="line72"> 72: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"factored matrix nonzeros = %D\n"</font>,(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)info.nz_used);

<a name="line74"> 74: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(u);
<a name="line75"> 75: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(b);
<a name="line76"> 76: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);
<a name="line77"> 77: </a>  <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(perm);
<a name="line78"> 78: </a>  <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(iperm);
<a name="line79"> 79: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line80"> 80: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(LU);

<a name="line82"> 82: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line83"> 83: </a>  <font color="#4169E1">return</font> 0;
<a name="line84"> 84: </a>}
</pre>
</body>

</html>
